#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf open-iscsi-2.0-871.tar.gz
    cd open-iscsi-2.0-871
    for MF in utils/Makefile utils/sysdeps/Makefile; do
	ed -s $MF >/dev/null <<EOF
/^CFLAGS +=/
s/-O2\W//
s/\W-g//
w
q
EOF
    done
    ed -s usr/iscsi_sysfs.c >/dev/null <<EOF
/<unistd\.h>/i
#include <sys/stat.h>
.
w
q
EOF
    make user OPTFLAGS=
    strip -R .note -R .comment usr/{iscsiadm,iscsid}
    mkdir -p ../iscsid/sbin
    cp usr/{iscsiadm,iscsid} ../iscsid/sbin/
    cd ..
#    rm -rf open-iscsi-2.0-871
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
